
//
// Trust Design LLC : SECS/HSMS Communication library
//
// (c) Copyright Trust Design LLC.  2010-2023.  All rights reserved.
//


// =============================================================================
//
// BasicIo : Test and sample program
//
//   Construct a message in AP and simply send and receive SECS messages.
//
//   (Note) In this sample, when making an HSMS connection, it is assumed that
//	the HOST side executes Passive connection and the EQUIP side executes
//	Active connection.
// 
//
// Starting method
//
//   FirstBasicIo {h|e}
//   ~~~~~~~~~~~~~~~~~~
//   h    : Refer to [HOST]  section of Sample.ini to determine operation
//   e    : Refer to [EQUIP] section of Sample.ini to determine operation
//
//   Normally, "FirstBasicIo h" and "FirstBasicIo e" both operate on same
//   machine or different machines to communicate with each other.
//
//   After startup, it refers to the menu display, inputs request codes (0,1,2).
//   And executes functions such as receiving a message from the other
//   side and sending a message to the other side.
//
//   When host starts up, it waits for a connection from equipment.
//   When equipment side is started, connection request and Select request are
//   automatically issued to host side. On host side, repeat "1:Recv" processing,
//   and confirm that display is "STATUS = 951: No data".  After that, exchange
//   any message. On receiving side, do not forget to reap received data until
//   "STATUS = 951".
//
//   This sample omits some of abnormal processing.
//
//   This sample operates under the following conditions.
//    a. for Windows
//    b. use _TDSUDrvXxxxx()
//    c. Do not use message definition file
//    d. The connection state is synchronized with the communication control
//       thread
//    e. SECS header is accessed in internal ByteOrder state
//    f. Use _TDSMssgNextL() for the communication trace displayed on the screen
//       and output in TDL format
//    g. Use the transaction ID of previously received primary message when
//       sending secondary message.
//
//
// =============================================================================
//
// FirstBasicIo : テスト 及び サンプル・プログラム
//
//  ＡＰ内でメッセージを構築し、単純に SECS メッセージの送受信を行う。
// 
//  "Sample0/BasicIo.c" の内容をもっと単純にしたもの。
//  処理の流れ等は "Sample0/BasicIo.c" の冒頭のコメントを参照すること。
// 
//   (注) 本サンプルでは HSMS 接続する場合、HOST 側が Passive 接続、EQUIP 側が
//	Active 接続を実行すると仮定している。
//
//
// 起動方法
//
//   FirstBasicIo {h|e}
//   ~~~~~~~~~~~~~~~~~~
//   h      : Sample.ini の [HOST]  セクションを参照し動作を決定する
//   e      : Sample.ini の [EQUIP]      :              :
//
//   通常、FirstBasicIo h 及び FirstBasicIo e の両方を、同一マシン、もしくは
//   異なるマシン上で動作させて、相互通信を行う。
//
//   起動後、メニュ表示を参照し、要求コード (0,1,2) を入力し、相手側からの
//   メッセージを受信したり、相手側へメッセージを送出する等の機能を実行する。
// 
//   ホスト側は起動すると、装置側からの接続を待つ。装置側を起動すると、自動的
//   にホスト側に接続要求、Select 要求を発行する。ホスト側では、1:Recv 処理を
//   繰り返し行い、表示が「STATUS=951 : No data」となるのを確認する。その後、
//   任意のメッセージのやりとりを行う。受信側では、受信データの刈り取りを「
//   STATUS=951」になるまで行うことを忘れぬこと。
//
//   本サンプルは、異常時処理を一部省略している。
//
//   本サンプルは、以下の条件で動作する。
//   a. Windows 用
//   b. _TDSUDrvXxxxx() を使用する
//   c. メッセージ定義ファイルを使用しない
//   d. 接続状態は通信制御スレッドと同期する
//   e. SECS ヘッダは、内部 ByteOrder 状態でアクセスする
//   f. 画面表示する通信トレースには _TDSMssgNextL() を使用し TDL 形式で出力する
//   g. ２次メッセージを送信する際のトランザクションＩＤは、直前に受信した１次
//      メッセージのものを使用する。
//
// =============================================================================

#include	"TDS.h"


#define		PO		fprintf(stdout
#define		PE		fprintf(stderr

#define		UDRV_MASK  	0x8383ffff	// Mask value for UDrvOpen()
						// 0          : Set =0x49
						// 0x8383ffff : All event
#define		PARAMFILE	"Sample.ini"

static void	Host();
static void	Equip();



// =============================================================================
// Common functions ============================================================

#include	"FirstSubFunctions.h"



// =============================================================================
// Main process ----------------------------------------------------------------

int
main(
int			argc,
char			*argv[])
{
  InitializeCriticalSection(&Cs1);

  if(argv[1][0]=='h')	Host ();
  else			Equip();

  DeleteCriticalSection(&Cs1);
  exit(0);
}



// =============================================================================
// Host side process -----------------------------------------------------------

static void
Host()
{
  TDSECSHead		hd;
  char			msg[1024];
  unsigned int		xid,xids=0;
  int			did,dids=0;
  int			req,rtn,sf,msz,mno;

  msz=sizeof(msg);
  if((Fd=_TDSUDrvOpen(0x1002,PARAMFILE,"HOST",UDRV_MASK))	< 0) goto Exit;
  PO,"(H) Opened (%d)\n",Fd);

  for(;;){
    PE,"Req (0:Exit 1:Recv 2:Send) : ");
    scanf("%d",&req);
    if      (req==0){						break;

    }else if(req==1){
      rtn=_TDSUDrvRecv(Fd,0,&did,&sf,&xid,msg,msz,&hd);
      if(rtn	  >=0){	dids=did;	xids=xid;}
      DispData(1,&hd,did,sf,xid,msg,rtn,rtn);

    }else if(req==2){
      PE,"Message(1:S1F1 2:S1F21 3:S2F49   6:S1F2 7:S1F22 8:S6F12) : ");
      scanf("%d",&mno);	rtn=0;
      switch(mno){
	case 1: rtn=SendS1F1 ();			break;
	case 2: rtn=SendS1F21();			break;
	case 3: rtn=SendS2F49();			break;
	case 6: rtn=SendS1F2H(dids,xids);		break;
	case 7: rtn=SendS1F22(dids,xids);		break;
	case 8: rtn=SendS6F12(dids,xids);		break;
    } }

    if(rtn<(-999) || ((-900)<rtn && rtn<0)){
      PE,"(H) I/O Error (%d)\n",	rtn);
  } }

Exit:
  if(Fd> 0)	_TDSUDrvClose(Fd,0);
  else		PE,"(H) Error (%d)\n",Fd);
}



// =============================================================================
// Equipment side process ------------------------------------------------------

static void
Equip()
{
  TDSECSHead		hd;
  char			msg[1024];
  unsigned int		xid,xids=0;
  int			did,dids=0;
  int			req,rtn,sf,msz,mno;

  msz=sizeof(msg);
  if((Fd=_TDSUDrvOpen(0x1002,PARAMFILE,"EQUIP",UDRV_MASK))	< 0) goto Exit;
  PO,"(E) Opened (%d)\n",Fd);

  for(;;){		rtn=0;
    PE,"Req (0:Exit 1:Recv 2:Send) : ");
    scanf("%d",&req);
    if      (req==0){						 break;

    }else if(req==1){
      rtn=_TDSUDrvRecv(Fd,0,&did,&sf,&xid,msg,msz,&hd);
      if(rtn	>=0){	dids=did; xids=xid;}
      DispData(1,&hd,did,sf,xid,msg,rtn,rtn);

    }else if(req==2){
      PE,"Message(1:S1F1 2:S1F21 3:S6F11   6:S1F2 7:S1F22 8:S2F50) : ");
      scanf("%d",&mno);	rtn=0;
      switch(mno){
	case 1: rtn=SendS1F1 ();			break;
	case 2: rtn=SendS1F21();			break;
	case 3: rtn=SendS6F11();			break;
	case 6: rtn=SendS1F2E(dids,xids);		break;
	case 7: rtn=SendS1F22(dids,xids);		break;
	case 8: rtn=SendS2F50(dids,xids);		break;
    } }

    if(rtn<(-999) || ((-900)<rtn && rtn<0)){
      PE,"(E) I/O Error (%d)\n",	rtn);
  } }

Exit:
  if(Fd> 0)	_TDSUDrvClose(Fd,0);
  else		PE,"(E) Error (%d)\n",Fd);
}
